/***********************************************************************/
/*** (C) Copyright A. Mangen 1994, C. Nguyen 1998                    ***/
/***   Modified by C. Nguyen 1998                                    ***/
/***********************************************************************/
/*** PROJECT     : RAY TRACING PROGRAM                               ***/
/*** PROGRAM NAME: TGA.H                                             ***/
/*** VERSION     : 1.3                                               ***/
/***-----------------------------------------------------------------***/
/*** DESCRIPTION : TARGA Graphic File Interface - Include File       ***/
/***               Only for direct color mapping (RGB in [0, 255])   ***/
/***               left to right, top to bottom                      ***/
/***********************************************************************/

/***********************************************************************/
/*** TGAHeader : Basic structure for the TARGA files                 ***/
/***********************************************************************/

struct TGAHeader {
  char IdLength,ColorMapType,ImageTypeCode;
  short int ColorMapOrigin,ColorMapLength; // warning : 2 bytes
  char ColorMapEntrySize;
  short int XOrigin,YOrigin,Width,Height; // warning : 2 bytes
  char ImagePixelSize,ImageDescriptorByte;
};

/***********************************************************************/
/*** TGAFile : Base class for TARGA files                            ***/
/***********************************************************************/

class TGAFile
{  FILE *fp;
   struct TGAHeader H;
   int BytesPerPixel;
public:
   TGAFile(char* FileName, int Width, int Height); // creation du fichier
   ~TGAFile(); // fermeture du fichier
   void WriteLine(int n, char* color); // ecriture d'une ligne de pixels
   void WritePixel(char* color); // ecriture d'un pixel
};
